[tor-commits] [tor/master] build: Add "make lsp" command

asn at torproject.org asn at torproject.org
Wed Dec 16 17:20:51 UTC 2020


commit 8b2d32435d626d878ddeb2348262d3efcdae8cbf
Author: David Goulet <dgoulet at torproject.org>
Date:   Wed Dec 16 10:01:15 2020 -0500

    build: Add "make lsp" command
    
    Generates the compile_commands.json file using the "bear" application so the
    ccls server can be more efficient with our code base.
    
    Closes #40227
    
    Signed-off-by: David Goulet <dgoulet at torproject.org>
---
 .gitignore                     |  3 +++
 Makefile.am                    | 14 ++++++++++++++
 changes/ticket40227            |  4 ++++
 scripts/maint/gen_ccls_file.sh | 20 ++++++++++++++++++++
 4 files changed, 41 insertions(+)

diff --git a/.gitignore b/.gitignore
index aa39162cad..06575f6351 100644
--- a/.gitignore
+++ b/.gitignore
@@ -37,6 +37,8 @@ details-*.json
 uptime-*.json
 *.full_url
 *.last_modified
+# ccls file that can be per directory.
+*.ccls
 
 # /
 /Makefile
@@ -74,6 +76,7 @@ uptime-*.json
 /Tor*Bundle.dmg
 /tor-*-win32.exe
 /warning_flags
+/compile_commands.json
 
 /coverage_html/
 /callgraph/
diff --git a/Makefile.am b/Makefile.am
index 6e8ba37e3a..3056b08446 100644
--- a/Makefile.am
+++ b/Makefile.am
@@ -725,3 +725,17 @@ show-libs:
 
 show-testing-libs:
 	@echo src/test/libtor-testing.a
+
+# Note here that we hardcode this -j2 because if the user would pass too many
+# cores, bear actually chockes and dies :S. For this to work, a make clean
+# needs to be done else bear will miss some compile flags.
+lsp:
+	@if test -x "`which bear 2>&1;true`"; then \
+		echo "Generating LSP compile_commands.json. Might take few minutes..."; \
+		$(MAKE) clean 2>&1 >/dev/null; \
+		bear >/dev/null 2>&1 -- $(MAKE) -j2 2>&1 >/dev/null; \
+		echo "Generating .ccls file..."; \
+		./scripts/maint/gen_ccls_file.sh \
+	else \
+		echo "No bear command found. On debian, apt install bear"; \
+	fi
diff --git a/changes/ticket40227 b/changes/ticket40227
new file mode 100644
index 0000000000..e5efad0f95
--- /dev/null
+++ b/changes/ticket40227
@@ -0,0 +1,4 @@
+  o Minor feature (build system):
+    - New "make lsp" command to auto generate the compile_commands.json file
+      used by the ccls server. The "bear" program is needed for this. Closes
+      ticket 40227.
diff --git a/scripts/maint/gen_ccls_file.sh b/scripts/maint/gen_ccls_file.sh
new file mode 100755
index 0000000000..899e4e9603
--- /dev/null
+++ b/scripts/maint/gen_ccls_file.sh
@@ -0,0 +1,20 @@
+#!/bin/sh
+
+##############################################################################
+# THIS MUST BE CALLED FROM THE ROOT DIRECTORY. IT IS USED BY THE MAKEFILE SO #
+# IN THEORY, YOU SHOULD NEVER CALL THIS.                                     #
+##############################################################################
+
+set -e
+
+CCLS_FILE=".ccls"
+
+# Get all #define *_PRIVATE from our source. We need to list them in our .ccls
+# file and enable them otherwise ccls will not find their definition thinking
+# that they are dead code.
+PRIVATE_DEFS=$(grep -r --include \*.h "_PRIVATE" | grep "#ifdef" | cut -d' ' -f2 | sort | uniq)
+
+echo "clang" > "$CCLS_FILE"
+for p in $PRIVATE_DEFS; do
+  echo "-D$p" >> "$CCLS_FILE"
+done



More information about the tor-commits mailing list